#include <IRremote.h>
#include <Adafruit_NeoPixel.h>
 
Adafruit_NeoPixel leds(12, 2, NEO_GRB + NEO_KHZ800);
long code;
int Reception = 5;

IRrecv irrecv(Reception);
decode_results results;

void setup() {
  irrecv.enableIRIn(); 
  leds.begin(); 
  leds.setBrightness(40);
  leds.show();}

void loop() {
  if (irrecv.decode(&results)==1)
  { code = results.value;
    irrecv.resume();}
  if(code==16753245){ //touche 1 blanc
    leds.fill(leds.Color(255, 255, 255), 0, 12);
    leds.show();}
  if(code==16736925){ //touche 2 jaune
    leds.fill(leds.Color(255, 255, 0), 0, 12);
    leds.show();}
  if(code==16769565){ //touche 3 vert
    leds.fill(leds.Color(0, 255, 0), 0, 12);
    leds.show();}
  if(code==16720605){ //touche 4 cyan
    leds.fill(leds.Color(0, 255, 255), 0, 12);
    leds.show(); }
  if(code==16712445){ //touche 5 bleu
    leds.fill(leds.Color(0, 0, 255), 0, 12);
    leds.show(); }
  if(code==16761405){ //touche 6 violet
    leds.fill(leds.Color(255, 0, 255), 0, 12);
    leds.show(); }
  if(code==16769055){ //touche 7 rouge
    leds.fill(leds.Color(255, 0, 0), 0, 12);
    leds.show(); }
  if(code==16754775){ //touche 8 feu
    uint32_t FeuOrange = leds.Color(255, 38, 0);
    uint32_t FeuOrange1 = leds.Color(255, 34, 0);
    uint32_t FeuOrange2 = leds.Color(255, 30, 0);
    uint32_t FeuOrange3 = leds.Color(255, 26, 0);
    uint32_t FeuOrange4 = leds.Color(255, 22, 0);
    rotation(FeuOrange, 5);
    leds.setBrightness(random(180,230));
    rotation(FeuOrange1, 13);
    leds.setBrightness(random(200,255));
    rotation(FeuOrange2, 7);
    leds.setBrightness(random(190,230));
    rotation(FeuOrange3, 11);
    leds.setBrightness(random(200,255));
    rotation(FeuOrange4, 6);
    leds.setBrightness(random(200,230));
    rotation(FeuOrange3, 4);
    leds.setBrightness(random(200,255));
    rotation(FeuOrange2, 8);
    leds.setBrightness(random(190,230));
    rotation(FeuOrange1, 10);
    leds.setBrightness(random(200,255));
    leds.show(); }
  if(code==16748655){ //touche 9 coeur
    leds.setBrightness(255);
    uint32_t FeuAmour = leds.Color(255, 0, 20);
    uint32_t FeuAmour1 = leds.Color(255, 0, 30);
    uint32_t FeuAmour2 = leds.Color(255, 0, 40);
    uint32_t FeuAmour3 = leds.Color(255, 0, 50);
    uint32_t FeuAmour4 = leds.Color(255, 0, 60); 
    rotation(FeuAmour, 16);
    rotation(FeuAmour1, 13);
    rotation(FeuAmour2, 8);
    rotation(FeuAmour3, 11);
    rotation(FeuAmour4, 9);
    rotation(FeuAmour3, 15);
    rotation(FeuAmour2, 12);
    rotation(FeuAmour1, 10);
    leds.show(); }
  if(code==16750695){ //touche 0
    leds.fill(leds.Color(0, 0, 0), 0, 12);
    leds.show(); }
  if(code==16738455){ //touche *
  couleurs(10); }
  if(code==16756815){ //touche #
    leds.fill(leds.Color(255, 255, 255), 0, 12);
    leds.show();
    delay(20);
    leds.fill(leds.Color(0, 0, 0), 0, 12);
    leds.show();
    delay(20); }
  if(code==16718055){ //touche fleche haut
    leds.setBrightness(210);
    leds.show(); }
  if(code==16730805){ //touche fleche bas
    leds.setBrightness(85);
    leds.show(); }
  if(code==16716015){ //touche fleche gauche
    leds.setBrightness(40);
    leds.show(); }
  if(code==16734885){ //touche fleche droite
    leds.setBrightness(170);
    leds.show(); }
  if(code==16726215){ //touche ok
    leds.setBrightness(255);
    leds.show(); }   
    delay(200); }
    
void rotation(uint32_t couleur, int temp) {
  for(uint16_t i=0; i<leds.numPixels(); i++) {
    leds.setPixelColor(i, couleur);
    leds.show();
    delay(temp); }
}
void couleurs(int temps) { 
  for(long PremiereLedCouleur = 0; PremiereLedCouleur < 65536; PremiereLedCouleur += 256) {
    for(int i=0; i<leds.numPixels(); i++) { 
      int ledTeinte = PremiereLedCouleur + (i * 65536 / leds.numPixels());
      leds.setPixelColor(i, leds.gamma32(leds.ColorHSV(ledTeinte))); }
    leds.show();  
    delay(temps); }
}
